%MACRO CHISPOOLING(DATAIN = COMBINED, DATAOUT = COMBINED, YEARLIST = , PREFIX = FNWTG);
	
	/*	GET #OF DATA FILE INVOLVED*/
	%LET NUM_FILE = %SYSFUNC(COUNTW(&YEARLIST., %STR( )));

	/*	GET ONE YEAR AND TWO YEAR FILE LIST*/
	%LET ONE_FILE = ;
	%LET TWO_FILE = ;
	%DO I = 1 %TO &NUM_FILE.;
		%LET TEMP_FILE = %SCAN(&YEARLIST.,&I., %STR( ));
		%IF %INDEX(&TEMP_FILE., _) > 0 %THEN %DO;
			%LET TWO_FILE = &TWO_FILE. &TEMP_FILE.;
		%END;
		%ELSE %IF %INDEX(&TEMP_FILE., _) = 0 %THEN %DO;
			%LET ONE_FILE = &ONE_FILE. &TEMP_FILE.;
		%END;
	%END;

	/*	GET #OF ONE AND TWO YEAR FILE*/
	%LET NUM_TWO_YEAR = %SYSFUNC(COUNTW(&TWO_FILE.,%STR( )));
	%LET NUM_ONE_YEAR = %SYSFUNC(COUNTW(&ONE_FILE.,%STR( )));

	/*	GET # OF YEARS INVOLVED. 2 YR DATAFILES COUNT AS 2. THIS */
	%LET NUM_YEAR = %EVAL(&NUM_TWO_YEAR. * 2+ &NUM_ONE_YEAR.);

	/*	GET # OF REPLICATE WEIGHTS*/
	%GLOBAL REPN;
	%LET REPN = %EVAL(80 * &NUM_FILE.);

	/*	WRITE SUMMARY OF ALL DATA FILE TO LOG*/
	%PUT **************INPUT DATA FILE SUMMARY***********************************;
	%PUT NOTE: INPUT YEAR LIST: &YEARLIST.;
	%PUT NOTE: # OF DATA FILE(S) INVOLVED: &NUM_FILE.;
	%PUT NOTE: # OF YEAR(S) OF DATA INVOLVED: &NUM_YEAR.;
	%PUT ************************************************************************;
	%PUT NOTE: &NUM_ONE_YEAR ONE YEAR FILE(S): &ONE_FILE.;
	%PUT ************************************************************************;
	%PUT NOTE: &NUM_TWO_YEAR TWO YEAR: &TWO_FILE.;
	%PUT **************OUTPUT OBJECT SUMMARY******************   ****************;
	%PUT NOTE: OUTPUT DATASET &DATAOUT. CONTAINS A TOTAL OF ;
	%PUT NOTE:     &REPN. REPLICATE WEIGHTS ARE GENERATED:;
	%PUT NOTE:     &PREFIX.1 - &PREFIX.&REPN.;
	%PUT NOTE: A GLOBAL MACRO VARIABLE: REPN IS GENERATED.;
	%PUT NOTE:     REPN = # OF REPLICATE WEIGHTS;
	%PUT ************************************************************************;

	DATA &DATAOUT.;
		SET &DATAIN.;
		/* BASE WEIGHT ADJUSTMENT */
		/* ONE-YEAR DATA*/
		%DO I = 1 %TO &NUM_ONE_YEAR.;
			%LET YEAR_TEMP = %SCAN(&ONE_FILE., &I., %STR( ));
			IF YEAR = "&YEAR_TEMP" THEN DO;
				&PREFIX.0 = RAKEDW0/&NUM_YEAR.;
			END;
		%END;
		/* TWO-YEAR DATA*/
		%DO I = 1 %TO &NUM_TWO_YEAR.;
			%LET YEAR_TEMP = %SCAN(&TWO_FILE., &I., %STR( ));
			IF YEAR = "&YEAR_TEMP" THEN DO;
				&PREFIX.0 = 2 * RAKEDW0/&NUM_YEAR.;
			END;
		%END;
		
		/* REPLICATE WEIGHT ADJUSTMENT*/
		ARRAY ORI_WEIGHT{*} RAKEDW1-RAKEDW80;
		
		%LET NUM_REP = %EVAL(80*&NUM_FILE.);
		ARRAY NEW_WEIGHT{*} &PREFIX.1-&PREFIX.&NUM_REP.;

		DO I = 1 TO 80;
			%DO J = 1 %TO &NUM_ONE_YEAR.;
				%LET YEAR_TEMP = %SCAN(&ONE_FILE., &J., %STR( ));
				IF YEAR = "&YEAR_TEMP." THEN DO;
					NEW_WEIGHT{(&J-1)*80 + I} = ORI_WEIGHT{I}/&NUM_YEAR.;
				END;
			%END;
			%DO J = %EVAL(1 + &NUM_ONE_YEAR.) %TO %EVAL(&NUM_TWO_YEAR. + &NUM_ONE_YEAR.);
				%LET YEAR_TEMP = %SCAN(&TWO_FILE., %EVAL(&J.-&NUM_ONE_YEAR.), %STR( ));
				IF YEAR = "&YEAR_TEMP." THEN DO;
					NEW_WEIGHT{(&J-1)*80 + I} = 2*ORI_WEIGHT{I}/&NUM_YEAR.;
				END;
			%END;
		END;
		DO I = 1 TO &NUM_REP.;
			IF NEW_WEIGHT{I} = . THEN NEW_WEIGHT{I} = &PREFIX.0;
		END;
	RUN;

%MEND;